'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.checkPairMusic = exports.handleDeadMusic = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _models = require('../../models');

var _utils = require('../../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var utils = new _utils.Utils();

var handleDeadMusic = exports.handleDeadMusic = function handleDeadMusic(songId, songInfo) {
  var songName = songInfo.songName,
      artist = songInfo.artist,
      album = songInfo.album,
      albumPic = songInfo.albumPic;

  _models.Song.findOrCreate({
    where: { songId: songId },
    defaults: {
      songId: songId,
      artist: artist,
      album: album,
      albumPic: albumPic,
      name: songName
    }
  }).then().catch(function (err) {
    return console.log(err);
  });
  _models.Recent.upsert({
    songId: songId
  }).then().catch(function (err) {
    return console.log(err);
  });
};

var checkPairMusic = exports.checkPairMusic = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(songId) {
    var pair, urlInfo;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            pair = void 0;
            _context.prev = 1;
            _context.next = 4;
            return _models.Pair.findOne({ where: { songId: songId } });

          case 4:
            pair = _context.sent;
            _context.next = 10;
            break;

          case 7:
            _context.prev = 7;
            _context.t0 = _context['catch'](1);
            throw new Error(_context.t0);

          case 10:
            if (!pair) {
              _context.next = 22;
              break;
            }

            urlInfo = void 0;
            _context.prev = 12;
            _context.next = 15;
            return utils.getUrlInfoForPair(pair.dataValues);

          case 15:
            urlInfo = _context.sent;
            _context.next = 21;
            break;

          case 18:
            _context.prev = 18;
            _context.t1 = _context['catch'](12);
            throw new Error(_context.t1);

          case 21:
            return _context.abrupt('return', urlInfo);

          case 22:
            return _context.abrupt('return', null);

          case 23:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined, [[1, 7], [12, 18]]);
  }));

  return function checkPairMusic(_x) {
    return _ref.apply(this, arguments);
  };
}();

exports.default = handleDeadMusic;