'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.player = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

require('colors');

var _utils = require('../../utils');

var _dead = require('./dead');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var utils = new _utils.Utils();

var player = exports.player = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(ctx, next) {
    var data, playbackReturnCode, songId, pair, songInfo, urlInfo;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            data = ctx.body;
            playbackReturnCode = data.data[0].code;
            songId = data.data[0].id;

            if (!(playbackReturnCode === 200)) {
              _context.next = 6;
              break;
            }

            console.log('The song URL is '.green + data.data[0].url);
            return _context.abrupt('return', next());

          case 6:
            pair = void 0;
            _context.prev = 7;
            _context.next = 10;
            return (0, _dead.checkPairMusic)(songId);

          case 10:
            pair = _context.sent;
            _context.next = 17;
            break;

          case 13:
            _context.prev = 13;
            _context.t0 = _context['catch'](7);

            console.log(_context.t0);
            throw new Error(_context.t0);

          case 17:
            if (!pair) {
              _context.next = 30;
              break;
            }

            _context.prev = 18;
            _context.next = 21;
            return _utils.Netease.modifyPlayerApiCustom(pair, data.data[0]);

          case 21:
            data.data[0] = _context.sent;
            _context.next = 28;
            break;

          case 24:
            _context.prev = 24;
            _context.t1 = _context['catch'](18);

            console.log('No resource.'.red);
            throw new Error(_context.t1);

          case 28:
            _context.next = 67;
            break;

          case 30:
            songInfo = void 0;
            _context.prev = 31;
            _context.next = 34;
            return _utils.Utils.getSongInfo(songId);

          case 34:
            songInfo = _context.sent;
            _context.next = 41;
            break;

          case 37:
            _context.prev = 37;
            _context.t2 = _context['catch'](31);

            console.log(_context.t2);
            throw new Error(_context.t2);

          case 41:
            urlInfo = void 0;
            _context.prev = 42;
            _context.next = 45;
            return utils.getUrlInfo(songInfo);

          case 45:
            urlInfo = _context.sent;
            _context.next = 52;
            break;

          case 48:
            _context.prev = 48;
            _context.t3 = _context['catch'](42);

            console.log(_context.t3);
            throw new Error(_context.t3);

          case 52:
            if (!urlInfo) {
              _context.next = 65;
              break;
            }

            _context.prev = 53;
            _context.next = 56;
            return _utils.Netease.modifyPlayerApiCustom(urlInfo, data.data[0]);

          case 56:
            data.data[0] = _context.sent;
            _context.next = 63;
            break;

          case 59:
            _context.prev = 59;
            _context.t4 = _context['catch'](53);

            console.log('No resource.'.red);
            throw new Error(_context.t4);

          case 63:
            _context.next = 67;
            break;

          case 65:
            console.log('No resource.'.red);
            (0, _dead.handleDeadMusic)(songId, songInfo);

          case 67:

            ctx.body = (0, _stringify2.default)(data);
            return _context.abrupt('return', next());

          case 69:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined, [[7, 13], [18, 24], [31, 37], [42, 48], [53, 59]]);
  }));

  return function player(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

exports.default = player;