// 参考 https://github.com/darknessomi/musicbox/wiki/

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _crypto = require('crypto');

var _crypto2 = _interopRequireDefault(_crypto);

var _bigInteger = require('big-integer');

var _bigInteger2 = _interopRequireDefault(_bigInteger);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var modulus = '00e0b509f6259df8642dbc35662901477df22677ec152b5ff68ace615bb7b725152b3ab17a876aea8a5aa76d2e417629ec4ee341f56135fccf695280104e0312ecbda92557c93870114af6c9d05c4f7f0c3685b7a46bee255932575cce10b424d813cfe4875d3e82047b97ddef52741d546b8e289dc6935b3ece0462db0a22b8e7';
var nonce = '0CoJUm6Qyw8W8jud';
var pubKey = '010001';

function createSecretKey(size) {
  var keys = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';
  var key = '';
  for (var i = 0; i < size; i += 1) {
    var pos = Math.random() * keys.length;
    pos = Math.floor(pos);
    key += keys.charAt(pos);
  }
  return key;
}

function aesEncrypt(text, secKey) {
  var lv = Buffer.from('0102030405060708', 'binary');
  var secKeyBin = Buffer.from(secKey, 'binary');
  var cipher = _crypto2.default.createCipheriv('AES-128-CBC', secKeyBin, lv);
  var encrypted = cipher.update(text, 'utf8', 'base64');
  encrypted += cipher.final('base64');
  return encrypted;
}

function zfill(str, size) {
  while (str.length < size) {
    str = '0' + str;
  }return str;
}

function rsaEncrypt(text) {
  var reverseText = text.split('').reverse().join('');
  var biText = (0, _bigInteger2.default)(Buffer.from(reverseText).toString('hex'), 16);
  var biEx = (0, _bigInteger2.default)(pubKey, 16);
  var biMod = (0, _bigInteger2.default)(modulus, 16);
  var biRet = biText.modPow(biEx, biMod);
  return zfill(biRet.toString(16), 256);
}

function Encrypt(obj) {
  var text = (0, _stringify2.default)(obj);
  var secKey = createSecretKey(16);
  var encText = aesEncrypt(aesEncrypt(text, nonce), secKey);
  var encSecKey = rsaEncrypt(secKey, pubKey, modulus);
  return {
    params: encText,
    encSecKey: encSecKey
  };
}

exports.default = Encrypt;