'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.sendRequest = exports.Netease = exports.Utils = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _netease = require('./netease');

Object.defineProperty(exports, 'Netease', {
  enumerable: true,
  get: function get() {
    return _netease.Netease;
  }
});

var _common = require('./common');

Object.defineProperty(exports, 'sendRequest', {
  enumerable: true,
  get: function get() {
    return _common.sendRequest;
  }
});

require('colors');

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _config = require('../config');

var _config2 = _interopRequireDefault(_config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Utils = exports.Utils = function () {
  function Utils() {
    (0, _classCallCheck3.default)(this, Utils);

    var ip = _config2.default.forceIp ? _config2.default.forceIp : '223.252.199.7';
    this.netease = new _netease.Netease(ip);
    this.plugins = [];
    this.initPlugins();
  }

  (0, _createClass3.default)(Utils, [{
    key: 'initPlugins',
    value: function initPlugins() {
      var _this = this;

      _fs2.default.readdirSync(_path2.default.resolve(__dirname, 'plugins')).forEach(function (file) {
        // eslint-disable-next-line
        var Plugin = require(_path2.default.resolve(__dirname, 'plugins', file));
        _this.plugins.push(new Plugin());
      });
      this.plugins.sort(function (a, b) {
        return a.order - b.order;
      });
      // console.log(this.plugins);
    }
  }, {
    key: 'batchSeachMusic',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(songName, artist, album) {
        var result, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, plugin, keyword, searchResult, searchName, trueName;

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                result = [];
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context.prev = 4;
                _iterator = (0, _getIterator3.default)(this.plugins);

              case 6:
                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                  _context.next = 26;
                  break;
                }

                plugin = _step.value;

                console.log(('Search from ' + plugin.name).green);
                keyword = artist + ' ' + songName + ' ' + album;
                searchResult = void 0;
                _context.prev = 11;
                _context.next = 14;
                return plugin.search(keyword);

              case 14:
                searchResult = _context.sent;
                _context.next = 22;
                break;

              case 17:
                _context.prev = 17;
                _context.t0 = _context['catch'](11);

                console.log(('Cannot search from ' + plugin.name).red);
                console.log(_context.t0);
                return _context.abrupt('continue', 23);

              case 22:
                if (searchResult.length > 0) {
                  // console.log(searchResult);
                  searchName = searchResult[0].name.replace(/ /g, '').toLowerCase();
                  trueName = songName.replace(/ /g, '').toLowerCase();

                  if (searchName.indexOf(trueName) !== -1) {
                    result.push({
                      plugin: plugin,
                      searchResult: searchResult[0]
                    });
                  } else {
                    console.log(('No resource found from ' + plugin.name).yellow);
                  }
                } else {
                  console.log(('No resource found from ' + plugin.name).yellow);
                }

              case 23:
                _iteratorNormalCompletion = true;
                _context.next = 6;
                break;

              case 26:
                _context.next = 32;
                break;

              case 28:
                _context.prev = 28;
                _context.t1 = _context['catch'](4);
                _didIteratorError = true;
                _iteratorError = _context.t1;

              case 32:
                _context.prev = 32;
                _context.prev = 33;

                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }

              case 35:
                _context.prev = 35;

                if (!_didIteratorError) {
                  _context.next = 38;
                  break;
                }

                throw _iteratorError;

              case 38:
                return _context.finish(35);

              case 39:
                return _context.finish(32);

              case 40:
                return _context.abrupt('return', result);

              case 41:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[4, 28, 32, 40], [11, 17], [33,, 35, 39]]);
      }));

      function batchSeachMusic(_x, _x2, _x3) {
        return _ref.apply(this, arguments);
      }

      return batchSeachMusic;
    }()
  }, {
    key: 'getUrlInfo',


    /*
      Get song url.
    */
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(songInfo) {
        var _songInfo, songName, artist, album, result, plugin, data, url;

        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _songInfo = songInfo, songName = _songInfo.songName, artist = _songInfo.artist, album = _songInfo.album;
                result = void 0;
                _context2.prev = 2;
                _context2.next = 5;
                return this.batchSeachMusic(songName, artist, album);

              case 5:
                result = _context2.sent;
                _context2.next = 12;
                break;

              case 8:
                _context2.prev = 8;
                _context2.t0 = _context2['catch'](2);

                console.log('Batch search failed.'.red);
                throw new Error(_context2.t0);

              case 12:
                result = result.sort(function (a, b) {
                  if (!a) {
                    return 1;
                  }
                  if (!b) {
                    return -1;
                  }
                  if (parseInt(a.searchResult.bitrate, 10) > parseInt(b.searchResult.bitrate, 10)) {
                    return -1;
                  }
                  if (parseInt(a.searchResult.bitrate, 10) < parseInt(b.searchResult.bitrate, 10)) {
                    return 1;
                  }
                  if (a.searchResult.bitrate === b.searchResult.bitrate) {
                    return a.searchResult.order - b.searchResult.order;
                  }
                  return 0;
                });

                if (!result[0]) {
                  _context2.next = 32;
                  break;
                }

                plugin = result[0].plugin;
                data = result[0].searchResult;

                songInfo = {
                  bitrate: data.bitrate,
                  filesize: data.filesize,
                  hash: data.hash,
                  type: data.type
                };
                url = void 0;
                _context2.prev = 18;
                _context2.next = 21;
                return plugin.getUrl(data);

              case 21:
                url = _context2.sent;
                _context2.next = 28;
                break;

              case 24:
                _context2.prev = 24;
                _context2.t1 = _context2['catch'](18);

                console.log('Cannot get song url'.red);
                throw new Error(_context2.t1);

              case 28:
                songInfo.origUrl = null;
                // 魔改 URL 应对某司防火墙
                if (_config2.default.rewriteUrl) {
                  songInfo.origUrl = url;
                  url = url.replace(plugin.baseUrl, 'music.163.com/' + plugin.name.replace(/ /g, '').toLowerCase());
                }
                songInfo.url = url;
                return _context2.abrupt('return', songInfo);

              case 32:
                return _context2.abrupt('return', null);

              case 33:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this, [[2, 8], [18, 24]]);
      }));

      function getUrlInfo(_x4) {
        return _ref2.apply(this, arguments);
      }

      return getUrlInfo;
    }()
  }, {
    key: 'getUrlInfoForPair',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(pair) {
        var plugin, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, p, url;

        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                plugin = void 0;
                _iteratorNormalCompletion2 = true;
                _didIteratorError2 = false;
                _iteratorError2 = undefined;
                _context3.prev = 4;
                _iterator2 = (0, _getIterator3.default)(this.plugins);

              case 6:
                if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
                  _context3.next = 14;
                  break;
                }

                p = _step2.value;

                if (!(p.name === pair.plugin)) {
                  _context3.next = 11;
                  break;
                }

                plugin = p;
                return _context3.abrupt('break', 14);

              case 11:
                _iteratorNormalCompletion2 = true;
                _context3.next = 6;
                break;

              case 14:
                _context3.next = 20;
                break;

              case 16:
                _context3.prev = 16;
                _context3.t0 = _context3['catch'](4);
                _didIteratorError2 = true;
                _iteratorError2 = _context3.t0;

              case 20:
                _context3.prev = 20;
                _context3.prev = 21;

                if (!_iteratorNormalCompletion2 && _iterator2.return) {
                  _iterator2.return();
                }

              case 23:
                _context3.prev = 23;

                if (!_didIteratorError2) {
                  _context3.next = 26;
                  break;
                }

                throw _iteratorError2;

              case 26:
                return _context3.finish(23);

              case 27:
                return _context3.finish(20);

              case 28:
                url = void 0;
                _context3.prev = 29;
                _context3.next = 32;
                return plugin.init();

              case 32:
                url = plugin.getUrl({
                  prefix: 'M800',
                  type: 'mp3',
                  mid: pair.hash
                });
                _context3.next = 38;
                break;

              case 35:
                _context3.prev = 35;
                _context3.t1 = _context3['catch'](29);
                throw new Error(_context3.t1);

              case 38:
                return _context3.abrupt('return', {
                  hash: '',
                  bitrate: '320000',
                  type: 'mp3',
                  url: url
                });

              case 39:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this, [[4, 16, 20, 28], [21,, 23, 27], [29, 35]]);
      }));

      function getUrlInfoForPair(_x5) {
        return _ref3.apply(this, arguments);
      }

      return getUrlInfoForPair;
    }()
  }], [{
    key: 'getSongInfo',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(songId) {
        var detail, songName, artist, album, albumPic;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                detail = void 0;
                _context4.prev = 1;
                _context4.next = 4;
                return _netease.Netease.getSongDetail(songId);

              case 4:
                detail = _context4.sent;
                _context4.next = 11;
                break;

              case 7:
                _context4.prev = 7;
                _context4.t0 = _context4['catch'](1);

                console.log('Cannot get song info from netease.'.red);
                throw new Error(_context4.t0);

              case 11:
                songName = _netease.Netease.getSongName(detail);
                artist = _netease.Netease.getArtistName(detail);
                album = _netease.Netease.getAlbumName(detail);
                albumPic = _netease.Netease.getAlbumPic(detail);

                console.log('Song name: '.green + songName);
                console.log('Artist: '.green + artist);
                console.log('Album: '.green + album);
                return _context4.abrupt('return', {
                  songName: songName, artist: artist, album: album, albumPic: albumPic
                });

              case 19:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this, [[1, 7]]);
      }));

      function getSongInfo(_x6) {
        return _ref4.apply(this, arguments);
      }

      return getSongInfo;
    }()
  }]);
  return Utils;
}();